
;23 juin 2015
; suite test OK avec 12F1840.. adaptation au 12F683
; config vue par Pickit2 : 0CD4
; FOSC interne =4MHZ  cycle=1S
; NOTA: deconnecter potar sur RA0 (=ICSP pin !) si probleme pour charger le HEX
; ou metre le potar de test  50%
; Program Memory Words Used:   212
; Byte RAM used : 13 (reste 3 spares)

;you can have a look on this 2 wires LCD interface in ASM use a 74HTC164 + classic LCD
;2-wire-lcd-74ls164-1b.jpg
;
;Hd44780 display commands:
; 0x0f = initiate display cursor on blinking
; 0x0c = initiate display cursor off
; 0x01 = clear display fills display with spaces (0x20).
; 0x02 = HOME returns to line one first character
; 0x38 = 2 lines X 16 char 8 bits mode. Defaults to 1 line mode.
; 0x10 = cursor left
; 0x14 = cursor right
; 0x18 = Shifts entire display left
; 0x1c = Shifts entire display right 
;Command(0x80); // begin on 1st line
;Command(0x80 + 0x40); // begin on 2nd line 


   List        P=12F683     ; List directive to define processor, to adapt to your Processor
   #Include    <p12f683.inc>    ;to adapt to your Processor specific variable definitions

	ERRORLEVEL      -302

; mettre en commantaire les 2 lignes ci dessous pour NE PAS AFFICHER la valeur 0123456789* et la valeur ANA sur le LCD 
#define Affiche
;define TestLeds

; config via MPLAB Configure
; Address    Value   Field             Category             Setting                                     
;    2007      3CD4  FOSC    Oscillator Selection bits      INTOSCIO: I/O on RA4/OSC2/CLKOUT pin, I/O on RA5/OSC1/CLKIN
;                    WDTE    Watchdog Timer Enable bit       WDT disabled                                                                     
;                    PWRTE   Power-up Timer Enable bit       PWRT disabled                                                                    
;                    MCLRE   MCLR Pin Function Select bit    MCLR pin function is digital input, MCLR internally tied to VDD                  
;                    CP      Code Protection bit             Program memory code protection is disabled                                       
;                    CPD     Data Code Protection bit        Data memory code protection is disabled                                          
;                    BOREN   Brown Out Detect                BOR disabled                                                                     
;                    IESO    Internal External Switchover bitInternal External Switchover mode is enabled                                     
;                    FCMEN   Fail-Safe Clock Monitor Enabled bitFail-Safe Clock Monitor is enabled
;                                               
;

;  __CONFIG _INTRC_OSC_NOCLKOUT  & _WDT_OFF  &_PWRTE_OFF & _BOD_OFF & _MCLRE_ON & _CP_OFF  & _CPD_OFF & _FCMEN_OFF  & _IESO_OFF 
; pour verif FOSC sur Pin3 GP4 CLCKOUT
   __CONFIG _INTRC_OSC_CLKOUT  & _WDT_OFF  &_PWRTE_OFF & _BOD_OFF & _MCLRE_ON & _CP_OFF  & _CPD_OFF & _FCMEN_OFF  & _IESO_OFF 
  
; test avec 
;MOVLW   b'01100000' ; 0, clock 4Mhz IRCF<2:0>= 110 ... clock source defined by FOSC<2:0>
;MOVWF   OSCCON 
; donne bien 1 Mhz sur pin 3 ClkOut = FOSC/4= 4MHz/4=1MHz

#Define Donnee  GPIO,1
#Define Clck GPIO,2

    ; Macros
ClckStrobe MACRO       ; Strobe the Data Bit
    bsf Clck
	NOP
    bcf Clck
    ENDM

EStrobe MACRO           ; Strobe the "E" Bit
    bsf Donnee
	NOP
    bcf Donnee
    ENDM


  	Cblock      0x020    ; to adapt for PIC10F200  ie : 0x010

	Temp                ; Temporary Value Used When Sending Out Data
	NOTemp            ; Temporary Value to "NybbleOutput"
	Result			; ADC 8 bits mesure 
	btmp; affichage octet --> decimal 3 digits ( de 0 a 255 )-> LCD

	DIVIS	; diviseur
	DIVID  ;
	QUOT  	;quotient
	REMAIN  ; reste

    count   ; utilis par tempos
    count1 ;  compteur

;#ifdef Affiche     ; error 102 ???? si declar ainsi !!
	bcent;
	bdix;
	bun;
;#endif

  	spare1
    spare2
    sparex		  
	endc

RamUtilisee EQU (sparex-0x20)		
	IF ( (RamUtilisee) > .15 )
		ERROR   "Attention debordement zone RAM de 16 bytes"
	ENDIF
    
 

    ORG 0x00        ; Processor Reset Vector
    goto    START       ; Go to beginning of program

    ORG 0x04        ; Interrupt Vector Location
	NOP
	NOP


START

  NOP
  NOP
  NOP
  BANKSEL OSCCON
  MOVLW   b'01100000' ; 0, clock 4Mhz IRCF<2:0>= 110 ... clock source defined by FOSC<2:0>
;111 = 8 MHz
;110 = 4MHz (default)
;101 = 2MHz (default)
;100 = 1MHz HF
   MOVWF   OSCCON   ; 
   NOP
NotStable
   BTFSS OSCCON,HTS
   GOTO NotStable

 	BANKSEL GPIO ;
	CLRF GPIO ;Init GPIO

    MOVLW 0x07			; comparators OFF
    MOVWF CMCON0
	BANKSEL TRISIO
    MOVLW   b'00011001'		; all inputs except GP1 GP2 G5 as output
	MOVWF TRISIO

    BANKSEL ANSEL
	MOVLW  b'00010001';  FOSC/8   AN0 
	MOVWF ANSEL
	MOVLW b'00000111' ; GPPU=0=enabled Presclar sur TM>R0, Prescaler=1/256   
    MOVWF OPTION_REG 
	MOVLW b'0110110'
    MOVWF WPU    ; active R de rappel sur PORT
    
; test clignotement de 2 leds sur GP1 et GP2
#ifdef TestLeds
Test
    MOVLW 0x02
    MOVWF GPIO
    call Dlay5 
    call Dlay5 
    MOVLW 0x04
    MOVWF GPIO
    call Dlay5 
    call Dlay5 
     goto Test
#endif


; Initialisation ADC channel 0
	BANKSEL ADRESH ;  bank0
	MOVLW  b'0000001' ;Left justify,VREF=VDD,CH=00=AN0,GO=0,ADON=1
	MOVWF ADCON0
    call    Tempo20mS    ; 
	BSF ADCON0,GO_DONE ;Start conversion
    NOP
	BTFSC ADCON0,GO_DONE ;Is conversion done?
	GOTO $-1 ;No, test again
	MOVF ADRESH,W ;Read MSB 
	MOVWF Result ;store it
    

; ===== Initialize LCD =====
   
    call Tempo200mS

 
    bcf STATUS, C   ; Clear Carry (Instruction Out)
    movlw   0x03        ; Reset Command
    call    NybbleOut   ; Send the Nybble
    call    Tempo5mS   ; Wait 5 msecs before Sending Again
    EStrobe
    call Tempo20mS   ; 
    EStrobe
    call Tempo20mS    ;
    bcf STATUS, C
    movlw   0x02        ; Set 4 Bit Mode
    call    NybbleOut
    call Tempo20mS
    movlw   0x28        ; Note that it is a 2 Line Display
    call    SendINS
    movlw   0x08        ; Turn off the Display
    call    SendINS
    movlw   0x01        ; Turn off the Display
    call    SendINS
    movlw   0x06        ; Turn off the Display
    call    SendINS

Loop      ; ---------- Loop Forever when Done-------------------------

   
    movlw   0x01        ; Clear the Display RAM
    call    SendINS
    call    Tempo5mS          ; Note, Can take up to 4.1 msecs
    movlw   0x06        ; Enable Cursor Move Direction
    call    SendINS
    movlw   0x0C        ; Turn the LCD Back On
    call    SendINS
	call Tempo20mS

#ifdef Affiche
; affiche de 0  9
   movlw '0'
   call    SendCHAR  
   movlw '1'
   call    SendCHAR  
   movlw '2'
   call    SendCHAR  
    movlw '3'
   call    SendCHAR  
   movlw '4'
   call    SendCHAR  
   movlw '5'
   call    SendCHAR  
   movlw '6'
   call    SendCHAR  
   movlw '7'
   call    SendCHAR 
   movlw '8'
   call    SendCHAR 
   movlw '9'
   call    SendCHAR  
#endif
 
 
   BANKSEL ADCON0  ; Ban0
   BSF ADCON0,GO_DONE ;Start conversion
   NOP
Encore
   BTFSC ADCON0,GO_DONE ;Is conversion done?
   GOTO Encore  ;No, test again
   MOVF ADRESH,W ;Read MSB 
   MOVWF Result ;store it
   MOVWF btmp 
   MOVWF DIVID

  
 
#ifdef Affiche
   movlw   0xC0        ; 2nd line of LCD 
   call    SendINS

;---- OPTION pour 12F683 -----
; affiche un compteur de boucle programme (every seconde) evolutif de 0 a 255 
  incf spare1
  movf spare1,w
  call bcd
  movlw '-' ; separateur
  call    SendCHAR
  movlw '>' ; separateur
  call    SendCHAR
;--------------------------------

   movf Result,W
   call  bcd ; affichage valeur de ADC 8 bits 
   movlw '*' ; separateur
   call    SendCHAR
#endif

; calcul vitesse en Beaufort 
   movlw .28   ; 255/28=9
   movwf DIVIS

divide          clrf    QUOT                   ;Clear quotient
                clrf    REMAIN                    ;Clear remainder
                movlw   0x08                   ;Bit count
                movwf   count
loopd           rlf     DIVID,F                ;Shift dividend bit
                rlf     REMAIN,F                  ;into remainder
                movf    DIVIS,W                ;Trial subtraction
                subwf   REMAIN,W
                skpnc
                movwf   REMAIN                    ;Subtraction was ok
                rlf     QUOT,F                 ;Carry is result bit
                decfsz  count,F                ;Next bit
                goto    loopd

   MOVF QUOT,W
   ADDLW '0'    ;   valeur en beaufort
   call    SendCHAR 
   
;---- OPTION pour  sur 12F683----
; LED change d'etat  chaque boucle programme (every 2 sec) 
  MOVLW b'00100000'
   XORWF GPIO,F    ; bascule sortie GP5
;-------------------------------------

   call Tempo1S

   goto        Loop


; ===== Subroutines =====

SendCHAR            ; Send the Character to the LCD
    movwf   Temp        ; Save the Temporary Value
    swapf   Temp, w     ; Send the High Nybble
    bsf STATUS, C   ; RS = 1
    call    NybbleOut
    movf    Temp, w     ; Send the Low Nybble
    bsf STATUS, C
    call    NybbleOut
    return

SendINS             ; Send the Instruction to the LCD
    movwf   Temp        ; Save the Temporary Value
    swapf   Temp, w     ; Send the High Nybble
    bcf STATUS, C   ; RS = 0
    call    NybbleOut
    movf    Temp, w     ; Send the Low Nybble
    bcf STATUS, C
    call    NybbleOut
    return

NybbleOut           ; Send a Nybble to the LCD
    movwf   NOTemp      ; Save the Nybble to Shift Out
    swapf   NOTemp,F      ; Setup to Output to the High Part of the Byte
    movlw   6       ; Clear the Shift Register
    movwf   count1

NO2Loop1
    ClckStrobe
    decfsz  count1,F
    goto    NO2Loop1
    movlw   5       ; #### - Now, Shift out the Data with the "RS" Bit
    movwf   count1
    bsf Donnee        ; Put out the Gate Bit
    ClckStrobe

NO2Loop2
    bcf Donnee        ; #### - Clear the Data Bit (which is the Clck)
    btfsc   STATUS, C   ; #### - If the Bit to be output is a "1", Shift it Out
    bsf Donnee
    ClckStrobe
    rlf NOTemp,F      ; #### - Shift the Next Bit into the Carry Flag
    decfsz  count1,F
    goto    NO2Loop2
    EStrobe         ; Strobe out the LCD Data
    return


#ifdef Affiche
bcd
		movwf  btmp		; affichage octet --> decimal 3 digits ( de 0 a 255 )-> RS232
		movlw  '0'
		movwf  bcent
		movwf  bdix
bcd1    movlw  .100
		subwf  btmp,w
		bnc    bcd2
		movwf  btmp
		incf   bcent,f
		goto   bcd1
bcd2  movlw  .10
		subwf  btmp,w
		bnc bcd3
		movwf btmp
		incf   bdix,f
		goto   bcd2
bcd3	movlw  '0'
		addwf  btmp,w
		movwf  bun
		movf   bcent,w
 	  call    SendCHAR  
		movf   bdix,w
	  call    SendCHAR  
		movf   bun,w
	  call    SendCHAR  
		return

#endif

Tempo5mS
; FOSC interne = 4MHz  cycle=1S
; (256-236)x (prescaler= 256)  * 1S = => 20*256*1=> 5 120 S => environ 5mS
	MOVLW .236
    MOVWF  TMR0
    BCF INTCON,T0IF
	NOP
MoreCycles
	BTFSS INTCON,T0IF
    GOTO  MoreCycles
    return

Tempo20mS
    MOVLW 4
    GOTO Te0

Tempo200mS
	MOVLW .10
    GOTO  Te0

Tempo1S:
	MOVLW .200
Te0:
    MOVWF count
Te1
    call Tempo5mS
    DECFSZ count,F
    GOTO Te1
    return

 end
----------------------------------------------------------------------
Release build of project `C:\_Mplab8\_Mesprojets_ASM\_12F6xx\12F683_LCD_2w.mcp' started.
Language tool versions: MPASMWIN.exe v5.51, mplink.exe v4.49, mplib.exe v4.49
Tue Jun 23 19:32:01 2015
----------------------------------------------------------------------
Clean: Deleting intermediary and output files.
Clean: Done.
Executing: "C:\Program Files (x86)\Microchip\MPASM Suite\MPASMWIN.exe" /q /p12F683 "12F683_LCD_2wires.asm" /l"12F683_LCD_2wires.lst" /e"12F683_LCD_2wires.err" /aINHX8M
Executing: "C:\Program Files (x86)\Microchip\MPASM Suite\mplink.exe" /p12F683 "12F683_LCD_2wires.o" /z__MPLAB_BUILD=1 /m"12F683_LCD_2wires.map" /w /o"12F683_LCD_2wires.cof" /x
MPLINK 4.49, Linker
Device Database Version 1.14
Copyright (c) 1998-2011 Microchip Technology Inc.
Errors    : 0

Loaded C:\_Mplab8\_Mesprojets_ASM\_12F6xx\12F683_LCD_2wires.cof.
----------------------------------------------------------------------
Release build of project `C:\_Mplab8\_Mesprojets_ASM\_12F6xx\12F683_LCD_2w.mcp' succeeded.
Language tool versions: MPASMWIN.exe v5.51, mplink.exe v4.49, mplib.exe v4.49
Tue Jun 23 19:32:03 2015
----------------------------------------------------------------------
BUILD SUCCEEDED
